
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Image &#8212; Documentation Segmentation Image 3.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Image</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/01/2019</span>
<span class="c1"># Classe Image Version 1.4</span>
<span class="c1">#####################################</span>

<span class="c1">### IMPORTATION DES BIBLIOTHEQUES </span>
<span class="c1">#import tkinter.filedialog as tkfd</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">matplotlib.image</span> <span class="k">as</span> <span class="nn">mpimg</span>
<span class="c1">#import tkinter as tk</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="c1">### IMPORTATION DES CLASSES</span>
<span class="kn">from</span> <span class="nn">Couleur</span> <span class="k">import</span> <span class="n">Couleur</span>

<span class="c1">### DEBUT de la classe Image</span>
<span class="c1">### contient IMPORT - EXPORT PNG en niveaux de gris &lt;-&gt; NUMPY ARRAY et AFFICHAGE </span>
<div class="viewcode-block" id="Image"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image">[docs]</a><span class="k">class</span> <span class="nc">Image</span><span class="p">:</span>
    
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    </span>
<span class="sd">    **AUTRES CLASSES IMPORTEES**</span>
<span class="sd">    </span>
<span class="sd">    * Couleur</span>
<span class="sd">    * matplotlib.pyplot</span>
<span class="sd">    * matplotlib.image</span>
<span class="sd">    * numpy</span>
<span class="sd">   </span>
<span class="sd">    </span>
<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Image.__init__"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">FilePath</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Constructeur d&#39;un objet Image</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :param FilePath: Chemin du fichier image à importer  </span>
<span class="sd">        :type FilePath: string        </span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Image</span>
<span class="sd">        :rtype: Image</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.file Chemin du fichier image sur la machine</span>
<span class="sd">        * self.image_np_gray Image importée au format png avec mpimg.imread </span>
<span class="sd">        * self.hauteur hauteur de l&#39;image en pixels</span>
<span class="sd">        * self.largeur largeur de l&#39;image en pixels</span>
<span class="sd">        * self.image_np_RGB Tableau numpy RGB obtenu à partir d&#39;un tableau numpy niveaux de gris (chacune des 3 valeurs est un flottant compris entre 0 et 1 et prend la vareur du niveau de gris de l&#39;image de départ)</span>
<span class="sd">        </span>
<span class="sd">        Pour les lignes et les colonnes je me place du point de vue de l&#39;image. </span>
<span class="sd">        Dans le tableau numpy, les coordonnées sont inversées.</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">file</span><span class="o">=</span><span class="n">FilePath</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">import_image_from_file</span><span class="p">()</span>
        <span class="c1"># Pour les lignes et les colonnes je me place du point de vue de l&#39;image</span>
        <span class="c1"># Dans le tableau numpy, les coordonnées sont inversées</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gray_2_RGB</span><span class="p">()</span></div>
    
<div class="viewcode-block" id="Image.import_image_from_file"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.import_image_from_file">[docs]</a>    <span class="k">def</span> <span class="nf">import_image_from_file</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Fonction de chargement de l&#39;image png accessible avec le chemin filepath et de conversion en tableau Numpy</span>

<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :return: le tableau Numpy correspondant à l&#39;image png situtée à l&#39;adresse self.FilePath</span>
<span class="sd">        :rtype: Numpy Array</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">return</span> <span class="n">mpimg</span><span class="o">.</span><span class="n">imread</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">file</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Image.gray_2_RGB"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.gray_2_RGB">[docs]</a>    <span class="k">def</span> <span class="nf">gray_2_RGB</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Fonction de conversion d&#39;un tableau numpy image importe du fichier image en niveaux de gris PNG en un tableau numpy png RGB.</span>
<span class="sd">        Les donnees de l&#39;image importée en niveaux de gris PNG sont recopiées dans un Numpy Array image RGB PNG qui est retourné.</span>
<span class="sd">        Pour chaque pixel, les valeurs de RVB sont toutes les trois égales au fichier en niveau de gris initial.</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :return: le tableau Numpy correspondant à l&#39;image png situtée à l&#39;adresse self.FilePath</span>
<span class="sd">        :rtype: Numpy Array</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1"># Initialisation des tableau numpy a la taille de l&#39;image et pleins de zeros</span>
        <span class="c1"># gray = np.zeros((hauteur,largeur))</span>
        <span class="n">gray_RGB</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">,</span><span class="mi">3</span><span class="p">))</span>
        <span class="c1"># Importation des donnees de l&#39;image dans les tableaux numpy, en niveau de gris d&#39;une part (pour le traitement)</span>
        <span class="c1"># en couleur RVB d&#39;autre part (pour l&#39;affichage et l&#39;export)</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">):</span>
                <span class="n">gray_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span>
                <span class="n">gray_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span>
                <span class="n">gray_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span>
        <span class="k">return</span> <span class="n">gray_RGB</span></div>

    <span class="c1">## Fonction de coloriage dans la couleur Couleur d&#39;une liste de points de l&#39;image dans un tableau NUMPY</span>

<div class="viewcode-block" id="Image.colorie_liste_points"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.colorie_liste_points">[docs]</a>    <span class="k">def</span> <span class="nf">colorie_liste_points</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">L</span><span class="p">,</span><span class="n">Color</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">         </span>
<span class="sd">        Procedure qui prend en entree une liste de points au format [x,y], une couleur de la liste List_couleur.  </span>
<span class="sd">        Elle change la couleur des points du tableau self.image_np_RGB (un tableau Numpy Array representant une image PNG en RVB) de coordonnées les valeurs se trouvant dans la liste pour Couleur. le tableau  est modifie par effets de bord</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :param L: Liste de points au format [x,y]</span>
<span class="sd">        :type L: List</span>
<span class="sd">        </span>
<span class="sd">        :param Color: une couleur du dictionnaire coul </span>
<span class="sd">        :type Color: str</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="n">color</span> <span class="o">=</span> <span class="n">Couleur</span><span class="p">(</span><span class="n">Color</span><span class="p">)</span>
        <span class="p">(</span><span class="n">rouge</span><span class="p">,</span><span class="n">vert</span><span class="p">,</span><span class="n">bleu</span><span class="p">)</span><span class="o">=</span> <span class="n">color</span><span class="o">.</span><span class="n">RVB_png</span>
        <span class="k">for</span> <span class="n">point</span> <span class="ow">in</span> <span class="n">L</span><span class="p">:</span>     <span class="c1"># un point est une liste de 2 cordonnees [x,y], y en vertical et x en horizontal lors de la capture</span>
            <span class="c1"># point[0] correspond à x sur l&#39;image, point[1] correspond à y sur l&#39;image. </span>
            <span class="c1"># Les coordonnées sont inversées sur le tableau où i correspond à l&#39;indice de ligne et j l&#39;indice de colonne</span>
            <span class="n">i</span><span class="o">=</span><span class="n">point</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">j</span><span class="o">=</span><span class="n">point</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">if</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">i</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span> <span class="ow">and</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">j</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">rouge</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">vert</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="n">bleu</span></div>
    
<div class="viewcode-block" id="Image.colorie_zone_img_RGB_np"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.colorie_zone_img_RGB_np">[docs]</a>    <span class="k">def</span> <span class="nf">colorie_zone_img_RGB_np</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">L</span><span class="p">,</span><span class="n">Couleur</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Colorie la zone determinee par L dans l&#39;image RGB avec la couleur Couleur</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :param L: Liste de points au format [x,y]</span>
<span class="sd">        :type L: List</span>
<span class="sd">        </span>
<span class="sd">        :param Color: une couleur du dictionnaire coul </span>
<span class="sd">        :type Color: str</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        :todo: voir l&#39;intérêt de cette foncttion par rapport à la précédente ???</span>
<span class="sd">        </span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">colorie_liste_points</span><span class="p">(</span><span class="n">L</span><span class="p">,</span><span class="n">Couleur</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Image.affiche_image_RGB"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.affiche_image_RGB">[docs]</a>    <span class="k">def</span> <span class="nf">affiche_image_RGB</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> 
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Affichage de l&#39;image self.image_np_RGB. (Numpy png niveaux de gris) </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>   
           
        <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span></div>
    
<div class="viewcode-block" id="Image.export_image_2_file"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.export_image_2_file">[docs]</a>    <span class="k">def</span> <span class="nf">export_image_2_file</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">chaine</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        </span>
<span class="sd">        Procedure exportant le tableau numpy image RGB en image png à l&#39;adresse FilePath modifiee. </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :param self: chaine de caractère servant à modifier le nom du fichier d&#39;enregistrement de l&#39;image à partir du nom de départ. </span>
<span class="sd">        :type self: Str</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="n">filepath_gray_RGB</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">file</span><span class="o">.</span><span class="n">rstrip</span><span class="p">(</span><span class="s1">&#39;.png&#39;</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;_&quot;</span><span class="o">+</span><span class="n">chaine</span><span class="o">+</span><span class="s2">&quot;_gray_RGB.png&quot;</span>
        <span class="n">mpimg</span><span class="o">.</span><span class="n">imsave</span><span class="p">(</span><span class="n">filepath_gray_RGB</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">image_np_RGB</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="Image.couleur_entier_8bits"><a class="viewcode-back" href="../tec_doc - Copie.html#Image.Image.couleur_entier_8bits">[docs]</a>    <span class="k">def</span> <span class="nf">couleur_entier_8bits</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Retourne la couleur(niveau de gris) du pixel de coordonnées (x,y) qui était codée comme flottant entre 0 et 1 comme entier entre 0 et 255</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Image </span>
<span class="sd">        :type self: Image</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du pixel sur l&#39;image. </span>
<span class="sd">        :type x: float</span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du pixel sur l&#39;image.</span>
<span class="sd">        :type y: float</span>
<span class="sd">        </span>
<span class="sd">        :return: le tableau Numpy correspondant à l&#39;image png situtée à l&#39;adresse self.FilePath</span>
<span class="sd">        :rtype: Numpy Array</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">Couleur</span><span class="o">.</span><span class="n">couleur_float_2_entier_8bits</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">image_np_gray</span><span class="p">[</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">])</span></div></div>
    
<span class="c1">### FIN DE LA CLASSE IMAGE</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>